/******************************************************************************
*                                                                             *
*       Copyright (C) 1993,1994 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

/* this is obsolete */

# include <sys/types.h>
# include <stdio.h>
# include "Slib.h"

int    Sargc;
char **Sargv = NULL;

void Sarginit(int argc, char **argv) {
  int i;

  Sargc = argc;
  if(Sargv != NULL) Sfree(Sargv);
  Sargv = Svector(argc, sizeof(*Sargv));

  for(i = 0; i < argc; i++)
    Sargv[i] = argv[i];
}

/* scan a command line for a given string and return 1 if found, 0 if not */

int Sarggetflag(char *flag) {
  int i;

  if(Sargv == NULL)
    Spanic("Sgetargflag: not initialised\n");

  for(i = 1; i < Sargc; i++)
    if(Sargv[i] != NULL && strcmp(Sargv[i], flag) == 0) {
      Sargv[i] = NULL;
      return(1);
    }   

  return(0);
}


/* scan a command line for a given string and return the following
   string or the default if the string is not present */

char *Sarggetstr(char *flag, char *defval) {
  int i;

  if(Sargv == NULL)
    Spanic("Sgetargstr: not initialised\n");

  for(i = 1; i < Sargc - 1; i++)
    if(Sargv[i] != NULL && strcmp(Sargv[i], flag) == 0)
      return(Sargv[i + 1]);

  return(defval);
}

long Sarggetld(char *flag, long defval) {
  int i;

  if(Sargv == NULL)
    Spanic("Sgetargstr: not initialised\n");

  for(i = 1; i < Sargc - 1; i++)
    if(Sargv[i] != NULL && strcmp(Sargv[i], flag) == 0) {
      long val;
      
      if(sscanf( Sargv[i + 1], "%ld", &val) != 1)
	Spanic("Sgetargint() bombed out\n");
      return(val);
    }

  return(defval);
}

double Sarggetlf(char *flag, double defval) {
  int i;

  if(Sargv == NULL)
    Spanic("Sgetargstr: not initialised\n");

  for(i = 1; i < Sargc - 1; i++)
    if(Sargv[i] != NULL && strcmp(Sargv[i], flag) == 0) {
      double val;
      
      if(sscanf( Sargv[i + 1], "%lf", &val) != 1)
	Spanic("Sgetarglf() bombed out\n");
      return(val);
    }

  return(defval);
}

/* check that all the consumed arguements from a contiguous block from
   the start and return the length of scanned argumnets.  Also free up
   the space used. */

int Sargquit() {
  int maxused, i, retval;

  for(maxused = Sargc - 1; maxused > 0 && Sargv[maxused] != NULL; maxused--);

  retval = maxused;

  for(i = 1; i < maxused; i++)
    if(Sargv[i] != NULL) {
      fprintf(stderr, "%s: argument not parsed:", Sargv[0]);
      while(i < maxused && Sargv[i] != NULL)
	fprintf(stderr, " %s", Sargv[i++]);
      fprintf(stderr, "\n");
      retval = 0;
    }

  Sfree(Sargv);

  return(retval);
}
