/******************************************************************************
*                                                                             *
*       Copyright (C) 1993,1994 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

/* needs stdio.h and sys/types.h included before this file */

void	Swav2acf(float*, int, float*, int);
float	Sacf2lpc(float*, int, float*, float*);
void	Slpc2cep(float*, int, float*, int);
void	Swav2cep(float*, int, float*, int);
int	Swav2zc(float*, int);


void	Spanic();
void	Sperror();
FILE*   Sfopen(char*, char*);
void	Sfclose(FILE*);
void	Sfread(void*, size_t, size_t, FILE*);
void	Sfwrite(void*, size_t, size_t, FILE*);
void	Sfseek(FILE*, long, int);

char*   Sreadln(FILE*);
void	Sreadln_reset();

void	Sswab(void*, void*, int);

void*   Smalloc(size_t);
void	Sfree(void*);
void*   Svector(size_t, size_t);
void**  Smatrix(size_t, size_t, size_t);
char*   Sfile2memory(char*);
short*  Sreadshortfile(char*, int, int, int*);
short*  Sfreadwave(FILE*, char*, int, int, int*);

float*	SmkHammwindow(int);
void	SHammwindow(short*, int, float*);
void	SzeroMeanHammWindow(short*, int, float*);

int	Sgetargs(int, char**, ...);

char**	Sreadlist(char*, int*);
char*** Sreadtable(char*, int*);
void    Swritetable(char ***, int, char*);

float	Sl2norm(float*, float*, int);
double	Sl2normd(double*, double*, int);
float	Sllikediag(float*, float*, float*, int);

float	Sviterbi(float**, float*, float**, float*, int, int, int*);
float	Sdtw(float**, int, float**, int, int);

void	Sfft(float*, float*, int);
void	Swav2psd(float*, int, float*, int);
void	Swav2fftacf(float*, int, float*, int);

/* useful numbers */

# define ALMOST_LOG_ZERO	(1e-30)
# define REALLY_VERY_BIG	(1e30)

#ifndef M_PI
#define M_PI          3.14159265358979323846
#endif
