/******************************************************************************
*                                                                             *
*       Copyright (C) 1993,1994 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

# include <sys/types.h>
# include <stdio.h>
# include <math.h>
# include "Slib.h"

void Smatrix_transpose(float **m0, float **m1, int m, int n) {
  int i, j;

  /* works in place for square matrices */
  if(m0 == m1) {
    if(m != n)
      Spanic("Matrix_transpose: same memory but different dimensions!\n");

    for(i = 0; i < n; i++)
      for(j = 0; j < i; j++) {
        float tmp = m0[i][j];
        m0[i][j] = m0[j][i];
        m0[j][i] = tmp;
      }
  }
  else
    for(i = 0; i < m; i++)
      for(j = 0; j < n; j++)
        m1[j][i] = m0[i][j];
}


/* multiply a m by n matrix with a n by p to give a m by p matrix */

void Smatrix_multiply(float **m0, float **m1, float **m2, int m, int n, int p){
  int i, j, k;

  for(i = 0; i < m; i++)
    for(j = 0; j < p; j++) {
      float sum = 0.0;
      
      for(k = 0; k < n; k++) sum += m0[i][k] * m1[k][j];
      m2[i][j] = sum;
    }
}

/* need free matrix inverse and eigenvector code */

