/******************************************************************************
*                                                                             *
*       Copyright (C) 1993,1994 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

# include <stdio.h>
# include <sys/types.h>
# include <malloc.h>
# include "Slib.h"

void *Smalloc(size_t nbyte) {
  void *address;

  if(nbyte == 0) nbyte = 1;

  if((address = malloc(nbyte)) == NULL)
    Sperror("Smalloc(%d) == NULL", nbyte);
  return(address);
}

void Sfree(void *address) {
  if(address == NULL) Spanic("Sfree(NULL)\n");
  free(address);
#ifdef FREE_RETURNS_STATUS
  if((char*) free(address) == NULL)
    Spanic("Sfree(%x) == NULL\n", (int) address);
#endif
}

/* vector gives a one dimensional array, matrix a two dimensional array
   and tensorx a x dimensional array. */

void *Svector(size_t nitem, size_t size) {
  int	nbyte = nitem * size;
  char *address;

  if(nbyte == 0) nbyte = 1;

  address = malloc(nbyte);

  if(address == NULL)
    Sperror("Svector(%d, %d)", nitem, size);

  return(address);
}

char **tmp_Char_2d_array(int size0, int size1) {
  char **array0;

  if((array0 = (char**) malloc(size0 * sizeof(char*) + size0 * size1)) !=NULL){
    char *array1 = (char*) (array0 + size0);
    int i;
    
    for(i = 0; i < size0; i++)
      array0[i] = array1 + i * size1;
  }
  return(array0);
}

/* this routine relies on sizeof(char) == 1 */

void **Smatrix(size_t nitem0, size_t nitem1, size_t size) {
  size_t nbyte;
  void **array0;
  char  *array1;
  int    i;

  nbyte = nitem0 * sizeof(char*) + nitem0 * nitem1 * size;

  if(nbyte == 0) nbyte = 1;

  array0 = malloc(nbyte);

  if(array0 == NULL)
    Sperror("Smatrix(%d, %d, %d)", nitem0, nitem1, size);

  array1 = (char*) (array0 + nitem0);

  for(i = 0; i < nitem0; i++)
    array0[i] = array1 + i * nitem1 * size;

  return(array0);
}

/* general N dimensional routines to go in here one day */

