/******************************************************************************
*                                                                             *
*       Copyright (C) 1993,1994 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

# include <sys/types.h>
# include <stdio.h>
# include <math.h>
# include "Slib.h"

# define SMALL 1E-30

float Spdf2gm(float *pdf, int npdf, float *mean, float *var, float *mix,
	      int nmix, int npass) {
  int pass, i;
  float cmean0 = mean[0], cmean1 = mean[1];
  float cvar0 = var[0], cvar1 = var[1];
  float cmix0 = mix[0], cmix1 = mix[1];

  Spanic("do not use Spdf2gm yet");
  
  for(pass = 0; pass < npass; pass++) {
    float nmix0 = 0.0, nmix1 = 0.0;
    float sum0one = 0.0, sum0two = 0.0, sum1one = 0.0, sum1two = 0.0;

    for(i = 0; i < npdf; i++) {
      float prob0, prob1, imix0;
	
      prob0 = cmix0 / sqrt(2.0 * M_PI * cvar0) * 
	exp(- (i - cmean0) * (i - cmean0) / (2.0 * cvar0)) + SMALL;
      prob1 = (1.0 - cmix0) / sqrt(2.0 * M_PI * cvar1) *
	exp(- (i - cmean1) * (i - cmean1) / (2.0 * cvar1)) + SMALL;
	
      imix0 = prob0 / (prob0 + prob1);
      nmix0 += imix0 * pdf[i];
      nmix1 += (1.0 - imix0) * pdf[i];
      sum0one += i * imix0 * pdf[i];
      sum0two += i * i * imix0 * pdf[i];
      sum1one += i * (1.0 - imix0) * pdf[i];
      sum1two += i * i * (1.0 - imix0) * pdf[i];
    }
/*
    printf("%f\t%f\t%f\t%f\n", sum0one, sum0two, sum1one, sum1two);
    printf("nmix0: %f\n", nmix0);
*/
    cmean0 = sum0one / nmix0;
    cvar0  = (sum0two - nmix0 * cmean0 * cmean0) / nmix0;
    cmean1 = sum1one / nmix1;
    cvar1  = (sum1two - nmix1 * cmean1 * cmean1) / nmix1;
    cmix0  = nmix0 / (nmix0 + nmix1);

    printf("%d\t%6.4f\t\t% 6.4f\t%6.4f\t\t% 6.4f\t%6.4f\n", 
	   pass, cmix0, cmean0, sqrt(cvar0), cmean1, sqrt(cvar1));

    mix[0]  = cmix0;
    mean[0] = cmean0;
    var[0]  = cvar0;

    mix[1]  = 1.0 - cmix0;
    mean[1] = cmean1;
    var[1]  = cvar1;
  }
  return(0.0);
}
