/******************************************************************************
*                                                                             *
*       Copyright (C) 1993,1994 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

# include <sys/types.h>
# include <stdio.h>
# include <math.h>
# include "Slib.h"
 
char **Sreadlist(char *filename, int *pnentry) {
  FILE	*ftxt;
  int	i, j, textsize;
  char  **entryv, *text;

  ftxt = Sfopen(filename, "r");
  Sfseek(ftxt, (long) 0, 2);
  textsize = ftell(ftxt);
  text = Smalloc(textsize);
  Sfseek(ftxt, (long) 0, 0);
  Sfread(text, 1, textsize, ftxt);
  Sfclose(ftxt);

  if(text[textsize - 1] != '\n')
    fprintf(stderr, "Sreadlist: file does not end in \\n: %s\n",
	    filename);

  *pnentry = 0;
  for(i = 0; i < textsize; i++) 
    if(text[i] == '\n') (*pnentry)++;

  entryv = (char**) Svector(*pnentry, sizeof(*entryv));
  j = 0;
  entryv[j++] = text;
  for(i = 0; i < textsize - 1; i++)
    if(text[i] == '\n') {
      text[i] = '\0';
      entryv[j++] = text + i + 1;
    }
  text[textsize - 1] = '\0';
  
  return(entryv);
}

char ***Sreadtable(char *filename, int *pnentry) {
  int i, maxnword = 0;
  char **list, ***table;

  list = Sreadlist(filename, pnentry);
  
  for(i = 0; i < *pnentry; i++) {
    int j = 0, nword = 1;

    while(list[i][j] != '\0') {
      if(list[i][j] == ' ' || list[i][j] == '\t') {
	while(list[i][j] == ' ' || list[i][j] == '\t') j++;
	nword++;
      }
      else {
	j++;
      }
    }

    if(nword > maxnword)
      maxnword = nword;
  }

  table = (char***) Smatrix(*pnentry, maxnword + 1, sizeof(char*));

  for(i = 0; i < *pnentry; i++) {
    int j = 0, nword = 0;

    fprintf(stderr, "%d\t%d\n", i, nword);
    fprintf(stderr, "%s\n", list[i]);
/*   table[i][0] = list[i]; */

    while(list[i][j] != '\0') {
      if(list[i][j] == ' ' || list[i][j] == '\t') {
	while(list[i][j] == ' ' || list[i][j] == '\t') list[i][j++] = '\0';
	nword++;

	table[i][nword] = list[i] + j;
	fprintf(stderr, "%s\n", table[i][nword]);
      }
      else {
	j++;
      }
    }
  }

  return(table);
}

void Swritetable(char ***table, int nentry, char *separator) {
  int i;

  if(separator == NULL)
    separator = " ";

  for(i = 0; i < nentry; i++) {
    int j;

    printf("%s", table[i][0]);

    for (j = 1; table[i][j][0] != '\0'; j++) {
      if(separator[1] != '\0')
	separator++;

      printf("%c%s", *separator, table[i][j]);
    }

    printf("\n");
  }
}
