/* a quick example of command line argument parsing */

# include <stdio.h>
# include <stdlib.h>
# include "Slib.h"

int main(int argc, char **argv) {
  int flag, nsum = 256;
  char type = 'i';
  float cons = 3.1415926535897;
  char *name = "/dev/null";
  char *filenamei, *filenameo;
  FILE *ifile = stdin, *ofile = stdout;

  Sgetargs(argc, argv, "-h", "-help", "-?", NULL,
	   "-flag", NULL,    &flag, "example of a flag",
	   "-type", "%c",    &type, "example of a character",
	   "-nsum", "%d",    &nsum, "example of an integer",
	   "-cons", "%6.4f", &cons, "example of a float",
	   "-name", "%s",    &name, "example of an arbitrary string",
	   NULL,
	   "in", "r", &ifile, &filenamei, "input file",
	   "out", "w", &ofile, &filenameo, "output file",
	   NULL);

  printf("flag: %d\n", flag);
  printf("type: %c\n", type);
  printf("nsum: %d\n", nsum);
  printf("cons: %f\n", cons);
  printf("name: %s\n", name);

  printf("input filename: %s\n", filenamei);
  printf("output filename: %s\n", filenameo);

  return(0);
}
