/******************************************************************************
*                                                                             *
*       Copyright (C) 1993 Tony Robinson				      *
*                                                                             *
*       See the file SLICENSE for conditions on distribution and usage	      *
*                                                                             *
******************************************************************************/

# include <sys/types.h>
# include <stdio.h>
# include <math.h>
# include "../Slib/Slib.h"

int main(int argc, char **argv) {
  short *sample;
  int  i, nfile = 0, nsample, diff = 0;
  FILE *infile, **outfile;

  if(argv[1][0] == '-') {
    if(strcmp(argv[1] + 1, "d") == 0) {
      diff = 1;
      nfile = argc - 3;
    }      
    else
      Spanic("syntax: %s [-d] infile outfile0 outfile1 ... outfilen\n", *argv);
  }      
  else
    nfile = argc - 2;

  if(nfile < 1)
    Spanic("not enough input files\n");

  sample  = Svector(nfile, sizeof(short));
  outfile = Svector(nfile, sizeof(FILE*));

  infile = Sfopen(argv[argc - nfile - 1], "r");

  for(i = 0; i < nfile; i++)
    outfile[i] = Sfopen(argv[argc - nfile + i], "w");

  while((nsample = fread(sample, sizeof(*sample), nfile, infile)) == nfile) {
    if(diff)
      for(i = 1; i < nfile; i++)
	sample[i] -= sample[0];

    for(i = 0; i < nfile; i++)
      Sfwrite(sample + i, sizeof(*sample), 1, outfile[i]);
  }

  if(nsample != 0)
    Spanic("samples discarded: %d\n", nsample);
  
  return(0);
}

